// Gmail Manager
// By Todd Long <longfocus@gmail.com>
// http://www.longfocus.com/firefox/gmanager/

var GM_gFinalHeight = 50;
var GM_gSlideIncrement = 1;
var GM_gSlideTime = 10;
var GM_gSwitchTime = 2000;
var GM_gOpenTime = 4000;
var GM_gSwitchOpenTime = 500;
var GM_gCancelTime = false;
var GM_gAccount = null;
var GM_gSnippets = null;
var GM_gSnippetsCurrent = 0;
var GM_gAlertClickable = false;
var GM_gAlertListener = null;

function GM_gAlertPrefillInfo()
{
  // unwrap all the args....
  // arguments[0] --> the mail account
  // arguments[1] --> is the text clickable?
  // arguments[2] --> the callback listener
  
  // Set the snippets
  GM_gAccount = window.arguments[0];
  GM_gSnippets = GM_gAccount.getSnippets({});
  
  // Set clickable
  GM_gAlertClickable = window.arguments[1];
  
  // Set the listener
  GM_gAlertListener = window.arguments[2];
  
  // Display the first snippet
  GM_gAlertPopulateInfo(GM_gSnippets[GM_gSnippetsCurrent]);
}

function GM_gAlertPopulateInfo(aSnippet)
{
  GM_getEBI("gm-alert-image").src = GM_GMAIL_ICON;
  GM_getEBI("gm-alert-email").value = GM_gAccount.email;
  GM_getEBI("gm-alert-count").value = GM_getBundleFString("alert-new-messages", [(GM_gSnippetsCurrent + 1), GM_gSnippets.length]);
  GM_getEBI("gm-alert-time").value = GM_unicode(aSnippet.time);
  GM_getEBI("gm-alert-from").value = GM_unicode(aSnippet.sender);
  GM_getEBI("gm-alert-subject").value = GM_unicode(aSnippet.subject);
  GM_setEBIA("gm-alert-msg", "clickable", (GM_gAlertClickable ? "true" : "false"));
  
  try {
    GM_getEBI("gm-alert-msg").firstChild.nodeValue = GM_unicode(aSnippet.msg);
  } catch (e) {
    GM_getEBI("gm-alert-msg").value = GM_unicode(aSnippet.msg);
  }
}

function GM_gAlertLoad()
{
  try {
    var prefBranch = GM_CC["@mozilla.org/preferences-service;1"].QueryInterface(GM_CI.nsIPrefService).getBranch(null);
    GM_gSlideIncrement = prefBranch.getIntPref("alerts.slideIncrement");
    GM_gSlideTime = prefBranch.getIntPref("alerts.slideIncrementTime");
    GM_gOpenTime = prefBranch.getIntPref("alerts.totalOpenTime");
  } catch(e) {}
  
  sizeToContent();
  
  GM_gFinalHeight = window.outerHeight;
  
  window.outerHeight = 1;
  window.moveTo((screen.availLeft + screen.availWidth - window.outerWidth) - 10, screen.availTop + screen.availHeight - window.outerHeight);
  
  setTimeout(GM_gAlertAnimate, GM_gSlideTime);
}

function GM_gAlertAnimate()
{
  if (GM_gCancelTime)
    return;
  
  if (window.outerHeight < GM_gFinalHeight)
  {
    window.screenY -= GM_gSlideIncrement;
    window.outerHeight += GM_gSlideIncrement;
    setTimeout(GM_gAlertAnimate, GM_gSlideTime);
  }
  else if (GM_gSnippetsCurrent < (GM_gSnippets.length - 1))
    setTimeout(GM_gAlertSwitch, GM_gSwitchTime);
  else
    setTimeout(GM_gAlertClose, GM_gOpenTime);
}

function GM_gAlertSwitch()
{
  if (GM_gCancelTime)
    return;
  
  if (GM_gSnippetsCurrent < (GM_gSnippets.length - 1))
  {
    GM_gAlertPopulateInfo(GM_gSnippets[++GM_gSnippetsCurrent]);
    setTimeout(GM_gAlertSwitch, GM_gSwitchTime);
  }
  else
    setTimeout(GM_gAlertClose, GM_gSwitchOpenTime);
}

function GM_gAlertClose()
{
  if (window.outerHeight > 1)
  {
    window.screenY += GM_gSlideIncrement;
    window.outerHeight -= GM_gSlideIncrement;
    setTimeout(GM_gAlertClose, GM_gSlideTime);
  }
  else
    GM_gAlertFinalClose();
}

function GM_gAlertFinalClose()
{
  // Close window
  window.close();
  
  // Notify alert finished
  if (GM_gAlertListener != null)
    GM_gAlertListener.observe(null, GM_NOTIFY_ACCOUNT_ALERT_FINISHED, null); 
}

function GM_gAlertAction(aId)
{
  switch (aId)
  {
    case "gm-alert-msg":
    {
      if (GM_gAlertClickable && GM_gAlertListener != null)
      {
        var account = GM_gAccount;
        
        // Close window
        GM_gAlertFinalClose();
        
        // Notify alert click
        if (GM_gAlertListener != null)
          GM_gAlertListener.observe(null, GM_NOTIFY_ACCOUNT_ALERT_LINK_CLICK, account);
      }
      break;
    }
    case "gm-alert-previous":
      if (GM_gSnippetsCurrent > 0)
        GM_gAlertPopulateInfo(GM_gSnippets[--GM_gSnippetsCurrent]);
      GM_gCancelTime = true;
      break;
    case "gm-alert-next":
      if (GM_gSnippetsCurrent < (GM_gSnippets.length - 1))
        GM_gAlertPopulateInfo(GM_gSnippets[++GM_gSnippetsCurrent]);
      GM_gCancelTime = true;
      break;
    case "gm-alert-close":
      GM_gAlertFinalClose();
      break;
  }
}