// Gmail Manager
// By Todd Long <longfocus@gmail.com>
// http://www.longfocus.com/firefox/gmanager/

var GM_gOverlayPopup = {
  populate: function(aId)
  {
    var popup = GM_getEBI(aId);
    var current = GM_gOverlay._current;
    var accounts = GM_gOverlay._accounts;
    var numAccounts = 0;
    var numLoggedIn = 0;
    var item = null;
    
    // Remove list items
    while (popup.hasChildNodes())
      popup.removeChild(popup.lastChild);
    
    // Loop accounts
    for (var email in accounts)
    {
      // Total accounts
      numAccounts++
      
      // Total accounts logged in
      if (accounts[email].loggedIn)
        numLoggedIn++;
    }
    
    if (numAccounts > 0)
    {
      item = document.createElement("menuitem");
      item.setAttribute("id", "gm-overlay-menuitem-loginall");
      item.setAttribute("label", GM_getBundleString("tb-popup-all-login"));
      item.setAttribute("oncommand", "GM_gOverlay.select(this.id);");
      item.setAttribute("disabled", (numLoggedIn == numAccounts));
      popup.appendChild(item);
      
      item = document.createElement("menuitem");
      item.setAttribute("id", "gm-overlay-menuitem-logoutall");
      item.setAttribute("label", GM_getBundleString("tb-popup-all-logout"));
      item.setAttribute("oncommand", "GM_gOverlay.select(this.id);");
      item.setAttribute("disabled", (numLoggedIn == 0));
      popup.appendChild(item);
      
      item = document.createElement("menuitem");
      item.setAttribute("id", "gm-overlay-menuitem-all-checknow");
      item.setAttribute("label", GM_getBundleString("tb-popup-all-check"));
      item.setAttribute("oncommand", "GM_gOverlay.select(this.id);");
      item.setAttribute("disabled", (numLoggedIn == 0));
      popup.appendChild(item);
      
      popup.appendChild(document.createElement("menuseparator"));
      
      if (accounts[current] != null)
      {
        var account = accounts[current];
        
        item = document.createElement("menuitem");
        item.setAttribute("id", "gm-overlay-menuitem-loginout");
        item.setAttribute("label", account.loggedIn ? GM_getBundleString("tb-popup-selected-logout") : 
									GM_getBundleString("tb-popup-selected-login"));
        item.setAttribute("oncommand", "GM_gOverlay.select(this.id);");
        popup.appendChild(item);
        
        if (account.loggedIn)
        {
          item = document.createElement("menuitem");
          item.setAttribute("id", "gm-overlay-menuitem-checknow");
          item.setAttribute("label", GM_getBundleString("tb-popup-selected-check"));
          item.setAttribute("oncommand", "GM_gOverlay.select(this.id);");
          popup.appendChild(item);
          
          item = document.createElement("menuitem");
          item.setAttribute("id", "gm-overlay-menuitem-showsnippets");
          item.setAttribute("label", GM_getBundleString("tb-popup-selected-snippets"));
          item.setAttribute("oncommand", "GM_gOverlay.select(this.id);");
          item.setAttribute("disabled", (account.getSnippets({}).length == 0));
          popup.appendChild(item);
        }
        
        popup.appendChild(document.createElement("menuseparator"));
      }
      
      for (var email in accounts)
      {
        var account = accounts[email];
        var unread = GM_gOverlay._getUnread(email);
        var checked = (current == email);
        
        // Account menu item
        item = document.createElement("menuitem");
        item.setAttribute("class", "gm-menuitem");
        item.setAttribute("type", "radio");
        item.setAttribute("checked", checked);
        item.setAttribute("default", checked);
        item.setAttribute("alias", account.alias);
        item.setAttribute("unread", unread);
        item.setAttribute("status", account.status);
        item.setAttribute("newMail", unread > 0);
        item.setAttribute("iconsize", "small");
        item.setAttribute("value", email);
        item.setAttribute("oncommand", "GM_gOverlay.selectAccount(this.value, true);");
        
        popup.appendChild(item);
      }
    }
    else
    {
      item = document.createElement("menuitem");
      item.setAttribute("label", GM_getBundleString("tb-popup-add-account"));
      item.setAttribute("oncommand", "window.openDialog('chrome://gmanager/content/accounts.xul', 'accounts', 'chrome,dependent=yes', 'add');");
      popup.appendChild(item);
    }
    
    popup.appendChild(document.createElement("menuseparator"));
    
    item = document.createElement("menuitem");
    item.setAttribute("label", GM_getBundleString("tb-popup-homepage"));
    item.setAttribute("accesskey", GM_getBundleString("tb-popup-homepage.ak"));
    item.setAttribute("oncommand", "GM_visitSite(GM_WEBSITE);");
    popup.appendChild(item);
    
    item = document.createElement("menuitem");
    item.setAttribute("label", GM_getBundleString("tb-popup-prefs"));
    item.setAttribute("accesskey", GM_getBundleString("tb-popup-prefs.ak"));
    item.setAttribute("default", "true");
    item.setAttribute("oncommand", "window.openDialog('chrome://gmanager/content/preferences.xul', 'prefs', 'centerscreen,chrome,dependent=yes');");
    popup.appendChild(item);
  }
}